/*
 * Copyright 2009
 *     PYRASIS.COM,.  All rights reserved.
 *
 * Author:
 *     Lee Jae-Hong (pyrasis)
 */

#define CONDITION_VARIABLE_LOCKMODE_SHARED 0x1

typedef struct _KCONDITION_VARIABLE {
    KEVENT Event;
    BOOLEAN Wake;
    BOOLEAN WakeAll;
    ULONG Waiters;
} KCONDITION_VARIABLE, *PKCONDITION_VARIABLE;

VOID
KeInitializeConditionVariable (
    __out PKCONDITION_VARIABLE ConditionVariable
    );

NTSTATUS
KeSleepConditionVariableMX (
    __inout PKCONDITION_VARIABLE ConditionVariable,
    __inout PKMUTEX Mutex,
    __in_opt PLARGE_INTEGER Timeout
    );

NTSTATUS
KeSleepConditionVariableRS (
    __inout PKCONDITION_VARIABLE ConditionVariable,
    __inout PERESOURCE Resource,
    __in_opt PLARGE_INTEGER Timeout,
    __in ULONG Flags
    );

VOID
KeWakeConditionVariable (
    __inout PKCONDITION_VARIABLE ConditionVariable
    );

VOID
KeWakeAllConditionVariable (
    __inout PKCONDITION_VARIABLE ConditionVariable
    );
